unit
  CrtFonts;

interface

const { 䨪 ⥬ }
  viUnknown = 0; viEGA = 1; viVGA = 2;
  VideoId : byte = viUnknown; 

type   { CRT-䮭 88, 814, 816 }
  PCrtFont8x8  = ^TCrtFont8x8;
  TCrtFont8x8  = array[$0000..$07FF] of byte;
  PCrtFont8x14 = ^TCrtFont8x14;
  TCrtFont8x14 = array[$0000..$0DFF] of byte;
  PCrtFont8x16 = ^TCrtFont8x16;
  TCrtFont8x16 = array[$0000..$0FFF] of byte;

procedure CrtFont8x8;
procedure CrtFont8x14;
procedure CrtFont8x16;

{
  楤 祭/⠭ CRT-䮭⮢
    FirstChar    - 1- 砥/塞 
    CharWidth    - "ਭ"    (8, 14, 16)
    Count        - 饥 - 砥/塞  (1...255)
    FontImagePtr -    / ண 砥/塞
                   
}

procedure SetCrtFont(FirstChar : char; CharWidth : byte; Count : word;
                     FontImagePtr : pointer);
procedure GetCrtFont(FirstChar : char; CharWidth : byte; Count : word;
                     FontImagePtr : pointer);

{ 楤 ⪫祭/祭 VGA ᯫ }
var
  ScreenOff : procedure;
  ScreenOn : procedure;

const
  ScreenIsOff : boolean = False;

implementation

procedure NothingToDo; far;
begin
end;

procedure VGAScreenOff; far; assembler;
asm
        mov dx,3c4h
        mov al,1
        out dx,al
        inc dx
        in al,dx
        or al,20h
        mov ah,al
        dec dx
        mov al,1
        out dx,al
        mov al,ah
        inc dx
        out dx,al
        mov ScreenIsOff, True;
end;

procedure VGAScreenOn; far; assembler;
asm
        mov dx,3c4h
        mov al,1
        out dx,al
        inc dx
        in al,dx
        and al,11011111b
        mov ah,al
        dec dx
        mov al,1
        out dx,al
        mov al,ah
        inc dx
        out dx,al
        mov ScreenIsOff, False;
end;

type
  PBuffer = ^TBuffer;
  TBuffer = array[0..$FFFE] of byte;

var
  FontRam : PBuffer;

procedure SetCrtFont;
var
  Buffer  : PBuffer absolute FontImagePtr;
  I       : word;
begin
  if (not CharWidth in [8, 14, 16]) or
     (Count < 1) or
     (Count > 256)
  then Exit;
  Port[$3C4]:=$02;
  Port[$3C5]:=$04;
  Port[$3C4]:=$04;
  Port[$3C5]:=$07;
  Port[$3CE]:=$05;
  Port[$3CF]:=$00;
  Port[$3CE]:=$06;
  Port[$3CF]:=$0C;
  for I:= 0 to Pred(Count) do
    Move(Buffer^[I * CharWidth],
         FontRam^[(Ord(FirstChar) + I) Shl 5],
         CharWidth);
  Port[$3CE]:=$06;
  Port[$3CF]:=$0E;
  Port[$3CE]:=$05;
  Port[$3CF]:=$10;
  Port[$3C4]:=$04;
  Port[$3C5]:=$03;
  Port[$3C4]:=$02;
  Port[$3C5]:=$03;
end;

procedure GetCrtFont;
var
  Buffer  : PBuffer absolute FontImagePtr;
  I       : word;
begin
  if (not CharWidth in [8, 14, 16]) or
     (Count < 1) or
     (Count > 256)
  then Exit;
  Port[$3C4] := $02;
  Port[$3C5] := $04;
  Port[$3C4] := $04;
  Port[$3C5] := $07;
  Port[$3CE] := $04;
  Port[$3CF] := $02;
  Port[$3CE] := $05;
  Port[$3CF] := $00;
  Port[$3CE] := $06;
  Port[$3CF] := $0C;
  for I:= 0 to Pred(Count) do
    Move(FontRam^[(Ord(FirstChar) + I) Shl 5],
         Buffer^[I * CharWidth],
         CharWidth);
  Port[$3CE] := $06;
  Port[$3CF] := $0E;
  Port[$3CE] := $05;
  Port[$3CF] := $10;
  Port[$3CE] := $04;
  Port[$3CF] := $00;
  Port[$3C4] := $04;
  Port[$3C5] := $03;
  Port[$3C4] := $02;
  Port[$3C5] := $03;
end;

procedure CrtFont8x8; assembler;
asm
	db	000h,000h,000h,000h,000h,000h,000h,000h
	db	07Eh,081h,0A5h,081h,0BDh,099h,081h,07Eh
	db	07Eh,0FFh,0DBh,0FFh,0C3h,0E7h,0FFh,07Eh
	db	06Ch,0FEh,0FEh,0FEh,07Ch,038h,010h,000h
	db	010h,038h,07Ch,0FEh,07Ch,038h,010h,000h
	db	038h,07Ch,038h,0FEh,0FEh,07Ch,038h,07Ch
	db	010h,010h,038h,07Ch,0FEh,07Ch,038h,07Ch
	db	000h,000h,018h,03Ch,03Ch,018h,000h,000h
	db	0FFh,0FFh,0E7h,0C3h,0C3h,0E7h,0FFh,0FFh
	db	000h,03Ch,066h,042h,042h,066h,03Ch,000h
	db	0FFh,0C3h,099h,0BDh,0BDh,099h,0C3h,0FFh
	db	00Fh,007h,00Fh,07Dh,0CCh,0CCh,0CCh,078h
	db	03Ch,066h,066h,066h,03Ch,018h,07Eh,018h
	db	03Fh,033h,03Fh,030h,030h,070h,0F0h,0E0h
	db	07Fh,063h,07Fh,063h,063h,067h,0E6h,0C0h
	db	099h,05Ah,03Ch,0E7h,0E7h,03Ch,05Ah,099h
	db	080h,0E0h,0F8h,0FEh,0F8h,0E0h,080h,000h
	db	002h,00Eh,03Eh,0FEh,03Eh,00Eh,002h,000h
	db	018h,03Ch,07Eh,018h,018h,07Eh,03Ch,018h
	db	066h,066h,066h,066h,066h,000h,066h,000h
	db	07Fh,0DBh,0DBh,07Bh,01Bh,01Bh,01Bh,000h
	db	03Eh,063h,038h,06Ch,06Ch,038h,0CCh,078h
	db	000h,000h,000h,000h,07Eh,07Eh,07Eh,000h
	db	018h,03Ch,07Eh,018h,07Eh,03Ch,018h,0FFh
	db	018h,03Ch,07Eh,018h,018h,018h,018h,000h
	db	018h,018h,018h,018h,07Eh,03Ch,018h,000h
	db	000h,018h,00Ch,0FEh,00Ch,018h,000h,000h
	db	000h,030h,060h,0FEh,060h,030h,000h,000h
	db	000h,000h,0C0h,0C0h,0C0h,0FEh,000h,000h
	db	000h,024h,066h,0FFh,066h,024h,000h,000h
	db	000h,018h,03Ch,07Eh,0FFh,0FFh,000h,000h
	db	000h,0FFh,0FFh,07Eh,03Ch,018h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h
	db	030h,078h,078h,030h,030h,000h,030h,000h
	db	06Ch,06Ch,06Ch,000h,000h,000h,000h,000h
	db	06Ch,06Ch,0FEh,06Ch,0FEh,06Ch,06Ch,000h
	db	030h,07Ch,0C0h,078h,00Ch,0F8h,030h,000h
	db	000h,0C6h,0CCh,018h,030h,066h,0C6h,000h
	db	038h,06Ch,038h,076h,0DCh,0CCh,076h,000h
	db	060h,060h,0C0h,000h,000h,000h,000h,000h
	db	018h,030h,060h,060h,060h,030h,018h,000h
	db	060h,030h,018h,018h,018h,030h,060h,000h
	db	000h,066h,03Ch,0FFh,03Ch,066h,000h,000h
	db	000h,030h,030h,0FCh,030h,030h,000h,000h
	db	000h,000h,000h,000h,000h,030h,030h,060h
	db	000h,000h,000h,0FCh,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,030h,030h,000h
	db	006h,00Ch,018h,030h,060h,0C0h,080h,000h
	db	07Ch,0C6h,0CEh,0DEh,0F6h,0E6h,07Ch,000h
	db	030h,070h,030h,030h,030h,030h,0FCh,000h
	db	078h,0CCh,00Ch,038h,060h,0CCh,0FCh,000h
	db	078h,0CCh,00Ch,038h,00Ch,0CCh,078h,000h
	db	01Ch,03Ch,06Ch,0CCh,0FEh,00Ch,01Eh,000h
	db	0FCh,0C0h,0F8h,00Ch,00Ch,0CCh,078h,000h
	db	038h,060h,0C0h,0F8h,0CCh,0CCh,078h,000h
	db	0FCh,0CCh,00Ch,018h,030h,030h,030h,000h
	db	078h,0CCh,0CCh,078h,0CCh,0CCh,078h,000h
	db	078h,0CCh,0CCh,07Ch,00Ch,018h,070h,000h
	db	000h,030h,030h,000h,000h,030h,030h,000h
	db	000h,030h,030h,000h,000h,030h,030h,060h
	db	018h,030h,060h,0C0h,060h,030h,018h,000h
	db	000h,000h,0FCh,000h,000h,0FCh,000h,000h
	db	060h,030h,018h,00Ch,018h,030h,060h,000h
	db	078h,0CCh,00Ch,018h,030h,000h,030h,000h
	db	07Ch,0C6h,0DEh,0DEh,0DEh,0C0h,078h,000h
	db	030h,078h,0CCh,0CCh,0FCh,0CCh,0CCh,000h
	db	0FCh,066h,066h,07Ch,066h,066h,0FCh,000h
	db	03Ch,066h,0C0h,0C0h,0C0h,066h,03Ch,000h
	db	0F8h,06Ch,066h,066h,066h,06Ch,0F8h,000h
	db	0FEh,062h,068h,078h,068h,062h,0FEh,000h
	db	0FEh,062h,068h,078h,068h,060h,0F0h,000h
	db	03Ch,066h,0C0h,0C0h,0CEh,066h,03Eh,000h
	db	0CCh,0CCh,0CCh,0FCh,0CCh,0CCh,0CCh,000h
	db	078h,030h,030h,030h,030h,030h,078h,000h
	db	01Eh,00Ch,00Ch,00Ch,0CCh,0CCh,078h,000h
	db	0E6h,066h,06Ch,078h,06Ch,066h,0E6h,000h
	db	0F0h,060h,060h,060h,062h,066h,0FEh,000h
	db	0C6h,0EEh,0FEh,0FEh,0D6h,0C6h,0C6h,000h
	db	0C6h,0E6h,0F6h,0DEh,0CEh,0C6h,0C6h,000h
	db	038h,06Ch,0C6h,0C6h,0C6h,06Ch,038h,000h
	db	0FCh,066h,066h,07Ch,060h,060h,0F0h,000h
	db	078h,0CCh,0CCh,0CCh,0DCh,078h,01Ch,000h
	db	0FCh,066h,066h,07Ch,06Ch,066h,0E6h,000h
	db	078h,0CCh,0E0h,070h,01Ch,0CCh,078h,000h
	db	0FCh,0B4h,030h,030h,030h,030h,078h,000h
	db	0CCh,0CCh,0CCh,0CCh,0CCh,0CCh,0FCh,000h
	db	0CCh,0CCh,0CCh,0CCh,0CCh,078h,030h,000h
	db	0C6h,0C6h,0C6h,0D6h,0FEh,0EEh,0C6h,000h
	db	0C6h,0C6h,06Ch,038h,038h,06Ch,0C6h,000h
	db	0CCh,0CCh,0CCh,078h,030h,030h,078h,000h
	db	0FEh,0C6h,08Ch,018h,032h,066h,0FEh,000h
	db	078h,060h,060h,060h,060h,060h,078h,000h
	db	0C0h,060h,030h,018h,00Ch,006h,002h,000h
	db	078h,018h,018h,018h,018h,018h,078h,000h
	db	010h,038h,06Ch,0C6h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,0FFh
	db	030h,030h,018h,000h,000h,000h,000h,000h
	db	000h,000h,078h,00Ch,07Ch,0CCh,076h,000h
	db	0E0h,060h,060h,07Ch,066h,066h,0DCh,000h
	db	000h,000h,078h,0CCh,0C0h,0CCh,078h,000h
	db	01Ch,00Ch,00Ch,07Ch,0CCh,0CCh,076h,000h
	db	000h,000h,078h,0CCh,0FCh,0C0h,078h,000h
	db	038h,06Ch,060h,0F0h,060h,060h,0F0h,000h
	db	000h,000h,076h,0CCh,0CCh,07Ch,00Ch,0F8h
	db	0E0h,060h,06Ch,076h,066h,066h,0E6h,000h
	db	030h,000h,070h,030h,030h,030h,078h,000h
	db	00Ch,000h,00Ch,00Ch,00Ch,0CCh,0CCh,078h
	db	0E0h,060h,066h,06Ch,078h,06Ch,0E6h,000h
	db	070h,030h,030h,030h,030h,030h,078h,000h
	db	000h,000h,0CCh,0FEh,0FEh,0D6h,0C6h,000h
	db	000h,000h,0F8h,0CCh,0CCh,0CCh,0CCh,000h
	db	000h,000h,078h,0CCh,0CCh,0CCh,078h,000h
	db	000h,000h,0DCh,066h,066h,07Ch,060h,0F0h
	db	000h,000h,076h,0CCh,0CCh,07Ch,00Ch,01Eh
	db	000h,000h,0DCh,076h,066h,060h,0F0h,000h
	db	000h,000h,07Ch,0C0h,078h,00Ch,0F8h,000h
	db	010h,030h,07Ch,030h,030h,034h,018h,000h
	db	000h,000h,0CCh,0CCh,0CCh,0CCh,076h,000h
	db	000h,000h,0CCh,0CCh,0CCh,078h,030h,000h
	db	000h,000h,0C6h,0D6h,0FEh,0FEh,06Ch,000h
	db	000h,000h,0C6h,06Ch,038h,06Ch,0C6h,000h
	db	000h,000h,0CCh,0CCh,0CCh,07Ch,00Ch,0F8h
	db	000h,000h,0FCh,098h,030h,064h,0FCh,000h
	db	01Ch,030h,030h,0E0h,030h,030h,01Ch,000h
	db	018h,018h,018h,000h,018h,018h,018h,000h
	db	0E0h,030h,030h,01Ch,030h,030h,0E0h,000h
	db	076h,0DCh,000h,000h,000h,000h,000h,000h
	db	000h,010h,038h,06Ch,0C6h,0C6h,0FEh,000h
	db	01Eh,036h,066h,066h,07Eh,066h,066h,000h
	db	07Ch,060h,060h,07Ch,066h,066h,07Ch,000h
	db	07Ch,066h,066h,07Ch,066h,066h,07Ch,000h
	db	07Eh,060h,060h,060h,060h,060h,060h,000h
	db	038h,06Ch,06Ch,06Ch,06Ch,06Ch,0FEh,0C6h
	db	07Eh,060h,060h,07Ch,060h,060h,07Eh,000h
	db	0DBh,0DBh,07Eh,03Ch,07Eh,0DBh,0DBh,000h
	db	03Ch,066h,006h,01Ch,006h,066h,03Ch,000h
	db	066h,066h,06Eh,07Eh,076h,066h,066h,000h
	db	03Ch,066h,06Eh,07Eh,076h,066h,066h,000h
	db	066h,06Ch,078h,070h,078h,06Ch,066h,000h
	db	01Eh,036h,066h,066h,066h,066h,066h,000h
	db	0C6h,0EEh,0FEh,0FEh,0D6h,0C6h,0C6h,000h
	db	066h,066h,066h,07Eh,066h,066h,066h,000h
	db	03Ch,066h,066h,066h,066h,066h,03Ch,000h
	db	07Eh,066h,066h,066h,066h,066h,066h,000h
	db	07Ch,066h,066h,066h,07Ch,060h,060h,000h
	db	03Ch,066h,060h,060h,060h,066h,03Ch,000h
	db	07Eh,018h,018h,018h,018h,018h,018h,000h
	db	066h,066h,066h,03Eh,006h,066h,03Ch,000h
	db	07Eh,0DBh,0DBh,0DBh,07Eh,018h,018h,000h
	db	066h,066h,03Ch,018h,03Ch,066h,066h,000h
	db	066h,066h,066h,066h,066h,066h,07Fh,003h
	db	066h,066h,066h,03Eh,006h,006h,006h,000h
	db	0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0FEh,000h
	db	0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0FFh,003h
	db	0E0h,060h,060h,07Ch,066h,066h,07Ch,000h
	db	0C6h,0C6h,0C6h,0F6h,0DEh,0DEh,0F6h,000h
	db	060h,060h,060h,07Ch,066h,066h,07Ch,000h
	db	078h,08Ch,006h,03Eh,006h,08Ch,078h,000h
	db	0CEh,0DBh,0DBh,0FBh,0DBh,0DBh,0CEh,000h
	db	03Eh,066h,066h,066h,03Eh,036h,066h,000h
	db	000h,000h,078h,00Ch,07Ch,0CCh,076h,000h
	db	000h,03Ch,060h,03Ch,066h,066h,03Ch,000h
	db	000h,000h,07Ch,066h,07Ch,066h,07Ch,000h
	db	000h,000h,07Eh,060h,060h,060h,060h,000h
	db	000h,000h,03Ch,06Ch,06Ch,06Ch,0FEh,0C6h
	db	000h,000h,03Ch,066h,07Eh,060h,03Ch,000h
	db	000h,000h,0DBh,07Eh,03Ch,07Eh,0DBh,000h
	db	000h,000h,03Ch,066h,00Ch,066h,03Ch,000h
	db	000h,000h,066h,06Eh,07Eh,076h,066h,000h
	db	000h,018h,066h,06Eh,07Eh,076h,066h,000h
	db	000h,000h,066h,06Ch,078h,06Ch,066h,000h
	db	000h,000h,01Eh,036h,066h,066h,066h,000h
	db	000h,000h,0C6h,0FEh,0FEh,0D6h,0C6h,000h
	db	000h,000h,066h,066h,07Eh,066h,066h,000h
	db	000h,000h,03Ch,066h,066h,066h,03Ch,000h
	db	000h,000h,07Eh,066h,066h,066h,066h,000h
	db	011h,044h,011h,044h,011h,044h,011h,044h
	db	055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh
	db	0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h
	db	018h,018h,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,0F8h,018h,018h,018h,018h
	db	018h,0F8h,018h,0F8h,018h,018h,018h,018h
	db	036h,036h,036h,0F6h,036h,036h,036h,036h
	db	000h,000h,000h,0FEh,036h,036h,036h,036h
	db	000h,0F8h,018h,0F8h,018h,018h,018h,018h
	db	036h,0F6h,006h,0F6h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,036h,036h,036h
	db	000h,0FEh,006h,0F6h,036h,036h,036h,036h
	db	036h,0F6h,006h,0FEh,000h,000h,000h,000h
	db	036h,036h,036h,0FEh,000h,000h,000h,000h
	db	018h,0F8h,018h,0F8h,000h,000h,000h,000h
	db	000h,000h,000h,0F8h,018h,018h,018h,018h
	db	018h,018h,018h,01Fh,000h,000h,000h,000h
	db	018h,018h,018h,0FFh,000h,000h,000h,000h
	db	000h,000h,000h,0FFh,018h,018h,018h,018h
	db	018h,018h,018h,01Fh,018h,018h,018h,018h
	db	000h,000h,000h,0FFh,000h,000h,000h,000h
	db	018h,018h,018h,0FFh,018h,018h,018h,018h
	db	018h,01Fh,018h,01Fh,018h,018h,018h,018h
	db	036h,036h,036h,037h,036h,036h,036h,036h
	db	036h,037h,030h,03Fh,000h,000h,000h,000h
	db	000h,03Fh,030h,037h,036h,036h,036h,036h
	db	036h,0F7h,000h,0FFh,000h,000h,000h,000h
	db	000h,0FFh,000h,0F7h,036h,036h,036h,036h
	db	036h,037h,030h,037h,036h,036h,036h,036h
	db	000h,0FFh,000h,0FFh,000h,000h,000h,000h
	db	036h,0F7h,000h,0F7h,036h,036h,036h,036h
	db	018h,0FFh,000h,0FFh,000h,000h,000h,000h
	db	036h,036h,036h,0FFh,000h,000h,000h,000h
	db	000h,0FFh,000h,0FFh,018h,018h,018h,018h
	db	000h,000h,000h,0FFh,036h,036h,036h,036h
	db	036h,036h,036h,03Fh,000h,000h,000h,000h
	db	018h,01Fh,018h,01Fh,000h,000h,000h,000h
	db	000h,01Fh,018h,01Fh,018h,018h,018h,018h
	db	000h,000h,000h,03Fh,036h,036h,036h,036h
	db	036h,036h,036h,0FFh,036h,036h,036h,036h
	db	018h,0FFh,018h,0FFh,018h,018h,018h,018h
	db	018h,018h,018h,0F8h,000h,000h,000h,000h
	db	000h,000h,000h,01Fh,018h,018h,018h,018h
	db	0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
	db	000h,000h,000h,0FFh,0FFh,0FFh,0FFh,0FFh
	db	0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h
	db	00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh
	db	0FFh,0FFh,0FFh,000h,000h,000h,000h,000h
	db	000h,000h,07Ch,066h,066h,07Ch,060h,000h
	db	000h,000h,03Ch,066h,060h,066h,03Ch,000h
	db	000h,000h,07Eh,018h,018h,018h,018h,000h
	db	000h,000h,066h,066h,03Eh,006h,03Ch,000h
	db	000h,000h,07Eh,0DBh,0DBh,07Eh,018h,000h
	db	000h,000h,066h,03Ch,018h,03Ch,066h,000h
	db	000h,000h,066h,066h,066h,066h,07Fh,003h
	db	000h,000h,066h,066h,03Eh,006h,006h,000h
	db	000h,000h,0D6h,0D6h,0D6h,0D6h,0FEh,000h
	db	000h,000h,0D6h,0D6h,0D6h,0D6h,0FFh,003h
	db	000h,000h,0E0h,060h,07Ch,066h,07Ch,000h
	db	000h,000h,0C6h,0C6h,0F6h,0DEh,0F6h,000h
	db	000h,000h,060h,060h,07Ch,066h,07Ch,000h
	db	000h,000h,03Ch,066h,01Eh,066h,03Ch,000h
	db	000h,000h,0CEh,0DBh,0FBh,0DBh,0CEh,000h
	db	000h,000h,03Eh,066h,03Eh,036h,066h,000h
	db	000h,0FEh,000h,0FEh,000h,0FEh,000h,000h
	db	000h,010h,010h,07Ch,010h,010h,000h,07Ch
	db	000h,030h,018h,00Ch,018h,030h,000h,07Ch
	db	000h,018h,030h,060h,030h,018h,000h,07Ch
	db	00Eh,01Bh,01Bh,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,0D8h,0D8h,070h
	db	000h,018h,018h,000h,07Eh,000h,018h,018h
	db	000h,076h,0DCh,000h,076h,0DCh,000h,000h
	db	000h,038h,06Ch,06Ch,038h,000h,000h,000h
	db	000h,000h,000h,000h,018h,000h,000h,000h
	db	000h,000h,000h,038h,038h,000h,000h,000h
	db	00Eh,00Ch,00Ch,00Ch,0ECh,03Ch,01Ch,00Ch
	db	03Ch,042h,099h,0A1h,0A1h,099h,042h,03Ch
	db	030h,048h,010h,020h,078h,000h,000h,000h
	db	000h,000h,07Ch,07Ch,07Ch,07Ch,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h
end;

procedure CrtFont8x14; assembler;
asm
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,07Eh,081h,0A5h,081h,081h,0BDh,099h,081h,07Eh,000h,000h,000h
	db	000h,000h,07Eh,0FFh,0DBh,0FFh,0FFh,0C3h,0E7h,0FFh,07Eh,000h,000h,000h
	db	000h,000h,000h,06Ch,0FEh,0FEh,0FEh,0FEh,07Ch,038h,010h,000h,000h,000h
	db	000h,000h,000h,010h,038h,07Ch,0FEh,07Ch,038h,010h,000h,000h,000h,000h
	db	000h,000h,018h,03Ch,03Ch,0E7h,0E7h,0E7h,018h,018h,03Ch,000h,000h,000h
	db	000h,000h,018h,03Ch,07Eh,0FFh,0FFh,07Eh,018h,018h,03Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,018h,03Ch,03Ch,018h,000h,000h,000h,000h,000h
	db	0FFh,0FFh,0FFh,0FFh,0FFh,0E7h,0C3h,0C3h,0E7h,0FFh,0FFh,0FFh,0FFh,0FFh
	db	000h,000h,000h,000h,03Ch,066h,042h,042h,066h,03Ch,000h,000h,000h,000h
	db	0FFh,0FFh,0FFh,0FFh,0C3h,099h,0BDh,0BDh,099h,0C3h,0FFh,0FFh,0FFh,0FFh
	db	000h,000h,01Eh,00Eh,01Ah,032h,078h,0CCh,0CCh,0CCh,078h,000h,000h,000h
	db	000h,000h,03Ch,066h,066h,066h,03Ch,018h,07Eh,018h,018h,000h,000h,000h
	db	000h,000h,03Fh,033h,03Fh,030h,030h,030h,070h,0F0h,0E0h,000h,000h,000h
	db	000h,000h,07Fh,063h,07Fh,063h,063h,063h,067h,0E7h,0E6h,0C0h,000h,000h
	db	000h,000h,018h,018h,0DBh,03Ch,0E7h,03Ch,0DBh,018h,018h,000h,000h,000h
	db	000h,000h,080h,0C0h,0F0h,0F8h,0FEh,0F8h,0F0h,0C0h,080h,000h,000h,000h
	db	000h,000h,002h,006h,01Eh,03Eh,0FEh,03Eh,01Eh,006h,002h,000h,000h,000h
	db	000h,000h,018h,03Ch,07Eh,018h,018h,018h,07Eh,03Ch,018h,000h,000h,000h
	db	000h,000h,066h,066h,066h,066h,066h,066h,000h,066h,066h,000h,000h,000h
	db	000h,000h,07Fh,0DBh,0DBh,0DBh,07Bh,01Bh,01Bh,01Bh,01Bh,000h,000h,000h
	db	000h,07Ch,0C6h,060h,038h,06Ch,0C6h,0C6h,06Ch,038h,00Ch,0C6h,07Ch,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,0FEh,0FEh,0FEh,000h,000h,000h
	db	000h,000h,018h,03Ch,07Eh,018h,018h,018h,07Eh,03Ch,018h,07Eh,000h,000h
	db	000h,000h,018h,03Ch,07Eh,018h,018h,018h,018h,018h,018h,000h,000h,000h
	db	000h,000h,018h,018h,018h,018h,018h,018h,07Eh,03Ch,018h,000h,000h,000h
	db	000h,000h,000h,000h,018h,00Ch,0FEh,00Ch,018h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,030h,060h,0FEh,060h,030h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C0h,0C0h,0C0h,0FEh,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,028h,06Ch,0FEh,06Ch,028h,000h,000h,000h,000h,000h
	db	000h,000h,000h,010h,038h,038h,07Ch,07Ch,0FEh,0FEh,000h,000h,000h,000h
	db	000h,000h,000h,0FEh,0FEh,07Ch,07Ch,038h,038h,010h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,018h,03Ch,03Ch,03Ch,018h,018h,000h,018h,018h,000h,000h,000h
	db	000h,066h,066h,066h,024h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,06Ch,06Ch,0FEh,06Ch,06Ch,06Ch,0FEh,06Ch,06Ch,000h,000h,000h
	db	000h,028h,028h,07Ch,0EEh,0E8h,07Ch,02Eh,0EEh,07Ch,028h,028h,000h,000h
	db	000h,000h,000h,000h,0C2h,0C6h,00Ch,018h,030h,066h,0C6h,000h,000h,000h
	db	000h,000h,038h,06Ch,06Ch,038h,076h,0DCh,0CCh,0CCh,076h,000h,000h,000h
	db	000h,030h,030h,030h,060h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,00Ch,018h,030h,030h,030h,030h,030h,018h,00Ch,000h,000h,000h
	db	000h,000h,030h,018h,00Ch,00Ch,00Ch,00Ch,00Ch,018h,030h,000h,000h,000h
	db	000h,000h,000h,000h,066h,03Ch,0FFh,03Ch,066h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,018h,018h,07Eh,018h,018h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,018h,018h,018h,030h,000h,000h
	db	000h,000h,000h,000h,000h,000h,0FEh,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,018h,018h,000h,000h,000h
	db	000h,000h,002h,006h,00Ch,018h,030h,060h,0C0h,080h,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0CEh,0DEh,0F6h,0E6h,0C6h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,018h,038h,078h,018h,018h,018h,018h,018h,07Eh,000h,000h,000h
	db	000h,000h,07Ch,0C6h,006h,00Ch,018h,030h,060h,0C6h,0FEh,000h,000h,000h
	db	000h,000h,07Ch,0C6h,006h,006h,03Ch,006h,006h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,00Ch,01Ch,03Ch,06Ch,0CCh,0FEh,00Ch,00Ch,01Eh,000h,000h,000h
	db	000h,000h,0FEh,0C0h,0C0h,0C0h,0FCh,006h,006h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,038h,060h,0C0h,0C0h,0FCh,0C6h,0C6h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,0FEh,0C6h,006h,00Ch,018h,030h,030h,030h,030h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,0C6h,07Ch,0C6h,0C6h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,0C6h,07Eh,006h,006h,00Ch,078h,000h,000h,000h
	db	000h,000h,000h,018h,018h,000h,000h,000h,018h,018h,000h,000h,000h,000h
	db	000h,000h,000h,018h,018h,000h,000h,000h,018h,018h,030h,000h,000h,000h
	db	000h,000h,006h,00Ch,018h,030h,060h,030h,018h,00Ch,006h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Eh,000h,000h,07Eh,000h,000h,000h,000h,000h
	db	000h,000h,060h,030h,018h,00Ch,006h,00Ch,018h,030h,060h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,00Ch,018h,018h,000h,018h,018h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,0DEh,0DEh,0DEh,0DCh,0C0h,07Ch,000h,000h,000h
	db	000h,000h,010h,038h,06Ch,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,0FCh,066h,066h,066h,07Ch,066h,066h,066h,0FCh,000h,000h,000h
	db	000h,000h,03Ch,066h,0C2h,0C0h,0C0h,0C0h,0C2h,066h,03Ch,000h,000h,000h
	db	000h,000h,0F8h,06Ch,066h,066h,066h,066h,066h,06Ch,0F8h,000h,000h,000h
	db	000h,000h,0FEh,066h,062h,068h,078h,068h,062h,066h,0FEh,000h,000h,000h
	db	000h,000h,0FEh,066h,062h,068h,078h,068h,060h,060h,0F0h,000h,000h,000h
	db	000h,000h,03Ch,066h,0C2h,0C0h,0C0h,0DEh,0C6h,066h,03Ah,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,03Ch,018h,018h,018h,018h,018h,018h,018h,03Ch,000h,000h,000h
	db	000h,000h,01Eh,00Ch,00Ch,00Ch,00Ch,00Ch,0CCh,0CCh,078h,000h,000h,000h
	db	000h,000h,0E6h,066h,06Ch,06Ch,078h,06Ch,06Ch,066h,0E6h,000h,000h,000h
	db	000h,000h,0F0h,060h,060h,060h,060h,060h,062h,066h,0FEh,000h,000h,000h
	db	000h,000h,0C6h,0EEh,0FEh,0FEh,0D6h,0C6h,0C6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,0C6h,0E6h,0F6h,0FEh,0DEh,0CEh,0C6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,038h,06Ch,0C6h,0C6h,0C6h,0C6h,0C6h,06Ch,038h,000h,000h,000h
	db	000h,000h,0FCh,066h,066h,066h,07Ch,060h,060h,060h,0F0h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,0C6h,0C6h,0D6h,0DEh,07Ch,00Ch,00Eh,000h,000h
	db	000h,000h,0FCh,066h,066h,066h,07Ch,06Ch,066h,066h,0E6h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,060h,038h,00Ch,0C6h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,07Eh,07Eh,05Ah,018h,018h,018h,018h,018h,03Ch,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,06Ch,038h,010h,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0D6h,0D6h,0FEh,07Ch,06Ch,000h,000h,000h
	db	000h,000h,0C6h,0C6h,06Ch,038h,038h,038h,06Ch,0C6h,0C6h,000h,000h,000h
	db	000h,000h,066h,066h,066h,066h,03Ch,018h,018h,018h,03Ch,000h,000h,000h
	db	000h,000h,0FEh,0C6h,08Ch,018h,030h,060h,0C2h,0C6h,0FEh,000h,000h,000h
	db	000h,000h,03Ch,030h,030h,030h,030h,030h,030h,030h,03Ch,000h,000h,000h
	db	000h,000h,080h,0C0h,0E0h,070h,038h,01Ch,00Eh,006h,002h,000h,000h,000h
	db	000h,000h,03Ch,00Ch,00Ch,00Ch,00Ch,00Ch,00Ch,00Ch,03Ch,000h,000h,000h
	db	010h,038h,06Ch,0C6h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,0FFh,000h
	db	030h,030h,018h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,078h,00Ch,07Ch,0CCh,0CCh,076h,000h,000h,000h
	db	000h,000h,0E0h,060h,060h,078h,06Ch,066h,066h,066h,07Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,0C0h,0C0h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,01Ch,00Ch,00Ch,03Ch,06Ch,0CCh,0CCh,0CCh,076h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,0FEh,0C0h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,038h,06Ch,064h,060h,0F0h,060h,060h,060h,0F0h,000h,000h,000h
	db	000h,000h,000h,000h,000h,076h,0CCh,0CCh,0CCh,07Ch,00Ch,0CCh,078h,000h
	db	000h,000h,0E0h,060h,060h,06Ch,076h,066h,066h,066h,0E6h,000h,000h,000h
	db	000h,000h,018h,018h,000h,038h,018h,018h,018h,018h,03Ch,000h,000h,000h
	db	000h,000h,006h,006h,000h,00Eh,006h,006h,006h,006h,066h,066h,03Ch,000h
	db	000h,000h,0E0h,060h,060h,066h,06Ch,078h,06Ch,066h,0E6h,000h,000h,000h
	db	000h,000h,038h,018h,018h,018h,018h,018h,018h,018h,03Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,0ECh,0FEh,0D6h,0D6h,0D6h,0C6h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0DCh,066h,066h,066h,066h,066h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,0C6h,0C6h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,0DCh,066h,066h,066h,07Ch,060h,060h,0F0h,000h
	db	000h,000h,000h,000h,000h,076h,0CCh,0CCh,0CCh,07Ch,00Ch,00Ch,01Eh,000h
	db	000h,000h,000h,000h,000h,0DCh,076h,066h,060h,060h,0F0h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,070h,01Ch,0C6h,07Ch,000h,000h,000h
	db	000h,000h,010h,030h,030h,0FCh,030h,030h,030h,036h,01Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,0CCh,0CCh,0CCh,0CCh,0CCh,076h,000h,000h,000h
	db	000h,000h,000h,000h,000h,066h,066h,066h,066h,03Ch,018h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0D6h,0D6h,0FEh,06Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,06Ch,038h,038h,06Ch,0C6h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0C6h,0C6h,07Eh,006h,00Ch,0F8h,000h
	db	000h,000h,000h,000h,000h,0FEh,0CCh,018h,030h,066h,0FEh,000h,000h,000h
	db	000h,000h,00Eh,018h,018h,018h,070h,018h,018h,018h,00Eh,000h,000h,000h
	db	000h,000h,018h,018h,018h,018h,000h,018h,018h,018h,018h,000h,000h,000h
	db	000h,000h,070h,018h,018h,018h,00Eh,018h,018h,018h,070h,000h,000h,000h
	db	000h,000h,076h,0DCh,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,010h,038h,06Ch,0C6h,0C6h,0FEh,000h,000h,000h,000h
	db	000h,000h,01Eh,036h,066h,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,0FEh,062h,060h,07Ch,066h,066h,066h,066h,0FCh,000h,000h,000h
	db	000h,000h,0FCh,066h,066h,066h,07Ch,066h,066h,066h,0FCh,000h,000h,000h
	db	000h,000h,0FEh,062h,062h,060h,060h,060h,060h,060h,0F0h,000h,000h,000h
	db	000h,000h,01Eh,036h,066h,066h,066h,066h,066h,066h,0FFh,0C3h,081h,000h
	db	000h,000h,0FEh,066h,062h,068h,078h,068h,062h,066h,0FEh,000h,000h,000h
	db	000h,000h,0D6h,0D6h,054h,054h,07Ch,054h,0D6h,0D6h,0D6h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,006h,006h,03Ch,006h,006h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0CEh,0DEh,0F6h,0E6h,0C6h,0C6h,0C6h,000h,000h,000h
	db	038h,038h,0C6h,0C6h,0CEh,0DEh,0F6h,0E6h,0C6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,0E6h,066h,06Ch,06Ch,078h,06Ch,06Ch,066h,0E6h,000h,000h,000h
	db	000h,000h,01Eh,036h,066h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,0C6h,0EEh,0FEh,0FEh,0D6h,0C6h,0C6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,0FEh,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,0FCh,066h,066h,066h,07Ch,060h,060h,060h,0F0h,000h,000h,000h
	db	000h,000h,03Ch,066h,0C2h,0C0h,0C0h,0C0h,0C2h,066h,03Ch,000h,000h,000h
	db	000h,000h,07Eh,05Ah,018h,018h,018h,018h,018h,018h,03Ch,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0C6h,07Eh,006h,0C6h,07Ch,000h,000h,000h
	db	000h,03Ch,018h,07Eh,0DBh,0DBh,0DBh,0DBh,07Eh,018h,03Ch,000h,000h,000h
	db	000h,000h,0C6h,0C6h,06Ch,07Ch,038h,07Ch,06Ch,0C6h,0C6h,000h,000h,000h
	db	000h,000h,0CCh,0CCh,0CCh,0CCh,0CCh,0CCh,0CCh,0CCh,0FEh,006h,006h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0C6h,07Eh,006h,006h,006h,000h,000h,000h
	db	000h,000h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0FEh,000h,000h,000h
	db	000h,000h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0FFh,003h,003h,000h
	db	000h,000h,0F8h,0B0h,030h,03Ch,036h,036h,036h,036h,07Ch,000h,000h,000h
	db	000h,000h,0C3h,0C3h,0C3h,0F3h,0DBh,0DBh,0DBh,0DBh,0F3h,000h,000h,000h
	db	000h,000h,0F0h,060h,060h,07Ch,066h,066h,066h,066h,0FCh,000h,000h,000h
	db	000h,000h,07Ch,0C6h,006h,026h,03Eh,026h,006h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,0CEh,0DBh,0DBh,0DBh,0FBh,0DBh,0DBh,0DBh,0CEh,000h,000h,000h
	db	000h,000h,03Fh,066h,066h,066h,03Eh,03Eh,066h,066h,0E7h,000h,000h,000h
	db	000h,000h,000h,000h,000h,078h,00Ch,07Ch,0CCh,0CCh,076h,000h,000h,000h
	db	000h,002h,006h,03Ch,060h,060h,07Ch,066h,066h,066h,03Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,0FCh,066h,07Ch,066h,066h,0FCh,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Eh,032h,030h,030h,030h,078h,000h,000h,000h
	db	000h,000h,000h,000h,000h,01Eh,036h,036h,066h,066h,0FFh,0C3h,0C3h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,0FEh,0C0h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,0D6h,0D6h,07Ch,054h,0D6h,0D6h,000h,000h,000h
	db	000h,000h,000h,000h,000h,03Ch,066h,00Ch,006h,066h,03Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0CEh,0D6h,0E6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,000h,038h,038h,0C6h,0CEh,0D6h,0E6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0E6h,06Ch,078h,078h,06Ch,0E6h,000h,000h,000h
	db	000h,000h,000h,000h,000h,01Eh,036h,066h,066h,066h,066h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0EEh,0FEh,0D6h,0D6h,0C6h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,0C6h,0C6h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,0FEh,0C6h,0C6h,0C6h,0C6h,0C6h,000h,000h,000h
	db	011h,044h,011h,044h,011h,044h,011h,044h,011h,044h,011h,044h,011h,044h
	db	055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh
	db	0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h
	db	018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,018h,018h,0F8h,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,0F8h,018h,0F8h,018h,018h,018h,018h,018h,018h
	db	036h,036h,036h,036h,036h,036h,036h,0F6h,036h,036h,036h,036h,036h,036h
	db	000h,000h,000h,000h,000h,000h,000h,0FEh,036h,036h,036h,036h,036h,036h
	db	000h,000h,000h,000h,000h,0F8h,018h,0F8h,018h,018h,018h,018h,018h,018h
	db	036h,036h,036h,036h,036h,0F6h,006h,0F6h,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,036h,036h,036h,036h,036h,036h,036h,036h,036h
	db	000h,000h,000h,000h,000h,0FEh,006h,0F6h,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,0F6h,006h,0FEh,000h,000h,000h,000h,000h,000h
	db	036h,036h,036h,036h,036h,036h,036h,0FEh,000h,000h,000h,000h,000h,000h
	db	018h,018h,018h,018h,018h,0F8h,018h,0F8h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,0F8h,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,018h,018h,01Fh,000h,000h,000h,000h,000h,000h
	db	018h,018h,018h,018h,018h,018h,018h,0FFh,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,0FFh,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,018h,018h,01Fh,018h,018h,018h,018h,018h,018h
	db	000h,000h,000h,000h,000h,000h,000h,0FFh,000h,000h,000h,000h,000h,000h
	db	018h,018h,018h,018h,018h,018h,018h,0FFh,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,01Fh,018h,01Fh,018h,018h,018h,018h,018h,018h
	db	036h,036h,036h,036h,036h,036h,036h,037h,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,037h,030h,03Fh,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,03Fh,030h,037h,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,0F7h,000h,0FFh,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0FFh,000h,0F7h,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,037h,030h,037h,036h,036h,036h,036h,036h,036h
	db	000h,000h,000h,000h,000h,0FFh,000h,0FFh,000h,000h,000h,000h,000h,000h
	db	036h,036h,036h,036h,036h,0F7h,000h,0F7h,036h,036h,036h,036h,036h,036h
	db	018h,018h,018h,018h,018h,0FFh,000h,0FFh,000h,000h,000h,000h,000h,000h
	db	036h,036h,036h,036h,036h,036h,036h,0FFh,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0FFh,000h,0FFh,018h,018h,018h,018h,018h,018h
	db	000h,000h,000h,000h,000h,000h,000h,0FFh,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,036h,036h,03Fh,000h,000h,000h,000h,000h,000h
	db	018h,018h,018h,018h,018h,01Fh,018h,01Fh,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,01Fh,018h,01Fh,018h,018h,018h,018h,018h,018h
	db	000h,000h,000h,000h,000h,000h,000h,03Fh,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,036h,036h,0FFh,036h,036h,036h,036h,036h,036h
	db	018h,018h,018h,018h,018h,0FFh,018h,0FFh,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,018h,018h,0F8h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,01Fh,018h,018h,018h,018h,018h,018h
	db	0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
	db	000h,000h,000h,000h,000h,000h,000h,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
	db	0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h
	db	00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh
	db	0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0DCh,066h,066h,066h,066h,07Ch,060h,0F0h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,0C0h,0C0h,0C6h,07Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Eh,05Ah,018h,018h,018h,03Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0C6h,0C6h,07Eh,006h,0C6h,07Ch,000h
	db	000h,000h,000h,000h,03Ch,018h,07Eh,0DBh,0DBh,0DBh,07Eh,018h,03Ch,000h
	db	000h,000h,000h,000h,000h,0C6h,06Ch,038h,038h,06Ch,0C6h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0CCh,0CCh,0CCh,0CCh,0CCh,0FEh,006h,006h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0C6h,07Eh,006h,006h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0D6h,0D6h,0D6h,0D6h,0D6h,0FEh,000h,000h,000h
	db	000h,000h,000h,000h,000h,0D6h,0D6h,0D6h,0D6h,0D6h,0FFh,003h,003h,000h
	db	000h,000h,000h,000h,000h,0F8h,0B0h,03Eh,033h,033h,07Eh,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0F6h,0DEh,0DEh,0F6h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0F0h,060h,07Ch,066h,066h,0FCh,000h,000h,000h
	db	000h,000h,000h,000h,000h,03Ch,066h,01Eh,006h,066h,03Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,0CEh,0DBh,0FBh,0DBh,0DBh,0CEh,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Eh,0CCh,07Ch,06Ch,0CCh,0CEh,000h,000h,000h
	db	000h,000h,000h,0FEh,000h,000h,0FEh,000h,000h,0FEh,000h,000h,000h,000h
	db	000h,000h,000h,018h,018h,07Eh,018h,018h,000h,000h,07Eh,000h,000h,000h
	db	000h,000h,030h,018h,00Ch,006h,00Ch,018h,030h,000h,07Eh,000h,000h,000h
	db	000h,000h,00Ch,018h,030h,060h,030h,018h,00Ch,000h,07Eh,000h,000h,000h
	db	000h,00Eh,01Bh,01Bh,01Bh,018h,018h,018h,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,018h,018h,018h,018h,0D8h,0D8h,0D8h,070h,000h
	db	000h,000h,000h,000h,018h,018h,000h,07Eh,000h,018h,018h,000h,000h,000h
	db	000h,000h,000h,000h,000h,076h,0DCh,000h,076h,0DCh,000h,000h,000h,000h
	db	000h,038h,06Ch,06Ch,038h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,018h,018h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,018h,000h,000h,000h,000h,000h
	db	000h,00Fh,00Ch,00Ch,00Ch,00Ch,00Ch,0ECh,07Ch,03Ch,01Ch,000h,000h,000h
	db	000h,000h,03Ch,042h,099h,0A5h,0A1h,0A5h,099h,042h,03Ch,000h,000h,000h
	db	000h,070h,0D8h,030h,060h,0C8h,0F8h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,07Ch,07Ch,07Ch,07Ch,07Ch,07Ch,07Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
end;

procedure CrtFont8x16; assembler;
asm
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,07Eh,081h,0A5h,081h,081h,0A5h,099h,081h,081h,07Eh,000h,000h,000h,000h
	db	000h,000h,07Eh,0FFh,0DBh,0FFh,0FFh,0DBh,0E7h,0FFh,0FFh,07Eh,000h,000h,000h,000h
	db	000h,000h,000h,000h,06Ch,0FEh,0FEh,0FEh,0FEh,07Ch,038h,010h,000h,000h,000h,000h
	db	000h,000h,000h,000h,010h,038h,07Ch,0FEh,07Ch,038h,010h,000h,000h,000h,000h,000h
	db	000h,000h,000h,018h,03Ch,03Ch,0E7h,0E7h,0E7h,018h,018h,03Ch,000h,000h,000h,000h
	db	000h,000h,000h,018h,03Ch,07Eh,0FFh,0FFh,07Eh,018h,018h,03Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,018h,03Ch,03Ch,018h,000h,000h,000h,000h,000h,000h
	db	0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0E7h,0C3h,0C3h,0E7h,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
	db	000h,000h,000h,000h,000h,03Ch,066h,042h,042h,066h,03Ch,000h,000h,000h,000h,000h
	db	0FFh,0FFh,0FFh,0FFh,0FFh,0C3h,099h,0BDh,0BDh,099h,0C3h,0FFh,0FFh,0FFh,0FFh,0FFh
	db	000h,000h,01Eh,006h,00Eh,01Ah,078h,0CCh,0CCh,0CCh,0CCh,078h,000h,000h,000h,000h
	db	000h,000h,03Ch,066h,066h,066h,066h,03Ch,018h,07Eh,018h,018h,000h,000h,000h,000h
	db	000h,000h,03Fh,033h,03Fh,030h,030h,030h,030h,070h,0F0h,0E0h,000h,000h,000h,000h
	db	000h,000h,07Fh,063h,07Fh,063h,063h,063h,063h,067h,0E7h,0E6h,0C0h,000h,000h,000h
	db	000h,000h,000h,018h,018h,0DBh,03Ch,0E7h,03Ch,0DBh,018h,018h,000h,000h,000h,000h
	db	000h,000h,000h,080h,0C0h,0F0h,0F8h,0FEh,0F8h,0F0h,0C0h,080h,000h,000h,000h,000h
	db	000h,000h,000h,002h,006h,01Eh,03Eh,0FEh,03Eh,01Eh,006h,002h,000h,000h,000h,000h
	db	000h,000h,018h,03Ch,07Eh,018h,018h,018h,07Eh,03Ch,018h,000h,000h,000h,000h,000h
	db	000h,000h,066h,066h,066h,066h,066h,066h,066h,000h,066h,066h,000h,000h,000h,000h
	db	000h,000h,07Fh,0DBh,0DBh,0DBh,07Bh,01Bh,01Bh,01Bh,01Bh,01Bh,000h,000h,000h,000h
	db	000h,07Ch,0C6h,060h,038h,06Ch,0C6h,0C6h,06Ch,038h,00Ch,0C6h,07Ch,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,0FEh,0FEh,0FEh,0FEh,000h,000h,000h,000h
	db	000h,000h,018h,03Ch,07Eh,018h,018h,018h,07Eh,03Ch,018h,07Eh,000h,000h,000h,000h
	db	000h,000h,018h,03Ch,07Eh,018h,018h,018h,018h,018h,018h,018h,000h,000h,000h,000h
	db	000h,000h,018h,018h,018h,018h,018h,018h,018h,07Eh,03Ch,018h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,018h,00Ch,0FEh,00Ch,018h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,030h,060h,0FEh,060h,030h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,0C0h,0C0h,0C0h,0FEh,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,028h,06Ch,0FEh,06Ch,028h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,010h,038h,038h,07Ch,07Ch,0FEh,0FEh,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,0FEh,0FEh,07Ch,07Ch,038h,038h,010h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,018h,03Ch,03Ch,03Ch,018h,018h,018h,000h,018h,018h,000h,000h,000h,000h
	db	000h,066h,066h,066h,024h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,06Ch,06Ch,0FEh,06Ch,06Ch,06Ch,0FEh,06Ch,06Ch,000h,000h,000h,000h
	db	000h,000h,028h,028h,07Ch,0EEh,0E8h,07Ch,02Eh,0EEh,07Ch,028h,028h,000h,000h,000h
	db	000h,000h,000h,000h,0C2h,0C6h,00Ch,018h,030h,060h,0C6h,086h,000h,000h,000h,000h
	db	000h,000h,038h,06Ch,06Ch,038h,076h,0DCh,0CCh,0CCh,0CCh,076h,000h,000h,000h,000h
	db	000h,030h,030h,030h,060h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,00Ch,018h,030h,030h,030h,030h,030h,030h,018h,00Ch,000h,000h,000h,000h
	db	000h,000h,030h,018h,00Ch,00Ch,00Ch,00Ch,00Ch,00Ch,018h,030h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,066h,03Ch,0FFh,03Ch,066h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,018h,018h,07Eh,018h,018h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,018h,018h,018h,030h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,0FEh,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,018h,018h,000h,000h,000h,000h
	db	000h,000h,000h,000h,002h,006h,00Ch,018h,030h,060h,0C0h,080h,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,0CEh,0DEh,0F6h,0E6h,0C6h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,018h,038h,078h,018h,018h,018h,018h,018h,018h,07Eh,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,006h,00Ch,018h,030h,060h,0C0h,0C6h,0FEh,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,006h,006h,03Ch,006h,006h,006h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,00Ch,01Ch,03Ch,06Ch,0CCh,0FEh,00Ch,00Ch,00Ch,01Eh,000h,000h,000h,000h
	db	000h,000h,0FEh,0C0h,0C0h,0C0h,0FCh,006h,006h,006h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,038h,060h,0C0h,0C0h,0FCh,0C6h,0C6h,0C6h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,0FEh,0C6h,006h,006h,00Ch,018h,030h,030h,030h,030h,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,0C6h,07Ch,0C6h,0C6h,0C6h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,0C6h,07Eh,006h,006h,006h,00Ch,078h,000h,000h,000h,000h
	db	000h,000h,000h,000h,018h,018h,000h,000h,000h,018h,018h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,018h,018h,000h,000h,000h,018h,018h,030h,000h,000h,000h,000h
	db	000h,000h,000h,006h,00Ch,018h,030h,060h,030h,018h,00Ch,006h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Eh,000h,000h,07Eh,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,060h,030h,018h,00Ch,006h,00Ch,018h,030h,060h,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,00Ch,018h,018h,018h,000h,018h,018h,000h,000h,000h,000h
	db	000h,000h,000h,07Ch,0C6h,0C6h,0DEh,0DEh,0DEh,0DCh,0C0h,07Ch,000h,000h,000h,000h
	db	000h,000h,010h,038h,06Ch,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,0FCh,066h,066h,066h,07Ch,066h,066h,066h,066h,0FCh,000h,000h,000h,000h
	db	000h,000h,03Ch,066h,0C2h,0C0h,0C0h,0C0h,0C0h,0C2h,066h,03Ch,000h,000h,000h,000h
	db	000h,000h,0F8h,06Ch,066h,066h,066h,066h,066h,066h,06Ch,0F8h,000h,000h,000h,000h
	db	000h,000h,0FEh,066h,062h,068h,078h,068h,060h,062h,066h,0FEh,000h,000h,000h,000h
	db	000h,000h,0FEh,066h,062h,068h,078h,068h,060h,060h,060h,0F0h,000h,000h,000h,000h
	db	000h,000h,03Ch,066h,0C2h,0C0h,0C0h,0DEh,0C6h,0C6h,066h,03Ah,000h,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,03Ch,018h,018h,018h,018h,018h,018h,018h,018h,03Ch,000h,000h,000h,000h
	db	000h,000h,01Eh,00Ch,00Ch,00Ch,00Ch,00Ch,0CCh,0CCh,0CCh,078h,000h,000h,000h,000h
	db	000h,000h,0E6h,066h,066h,06Ch,078h,078h,06Ch,066h,066h,0E6h,000h,000h,000h,000h
	db	000h,000h,0F0h,060h,060h,060h,060h,060h,060h,062h,066h,0FEh,000h,000h,000h,000h
	db	000h,000h,0C6h,0EEh,0FEh,0FEh,0D6h,0C6h,0C6h,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,0C6h,0E6h,0F6h,0FEh,0DEh,0CEh,0C6h,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,0FCh,066h,066h,066h,07Ch,060h,060h,060h,060h,0F0h,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0D6h,0DEh,07Ch,00Ch,00Eh,000h,000h
	db	000h,000h,0FCh,066h,066h,066h,07Ch,06Ch,066h,066h,066h,0E6h,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,060h,038h,00Ch,006h,0C6h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,07Eh,07Eh,05Ah,018h,018h,018h,018h,018h,018h,03Ch,000h,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,06Ch,038h,010h,000h,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0D6h,0D6h,0D6h,0FEh,0EEh,06Ch,000h,000h,000h,000h
	db	000h,000h,0C6h,0C6h,06Ch,07Ch,038h,038h,07Ch,06Ch,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,066h,066h,066h,066h,03Ch,018h,018h,018h,018h,03Ch,000h,000h,000h,000h
	db	000h,000h,0FEh,0C6h,086h,00Ch,018h,030h,060h,0C2h,0C6h,0FEh,000h,000h,000h,000h
	db	000h,000h,03Ch,030h,030h,030h,030h,030h,030h,030h,030h,03Ch,000h,000h,000h,000h
	db	000h,000h,000h,080h,0C0h,0E0h,070h,038h,01Ch,00Eh,006h,002h,000h,000h,000h,000h
	db	000h,000h,03Ch,00Ch,00Ch,00Ch,00Ch,00Ch,00Ch,00Ch,00Ch,03Ch,000h,000h,000h,000h
	db	010h,038h,06Ch,0C6h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,0FFh,000h,000h
	db	030h,030h,018h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,078h,00Ch,07Ch,0CCh,0CCh,0CCh,076h,000h,000h,000h,000h
	db	000h,000h,0E0h,060h,060h,078h,06Ch,066h,066h,066h,066h,07Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,0C0h,0C0h,0C0h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,01Ch,00Ch,00Ch,03Ch,06Ch,0CCh,0CCh,0CCh,0CCh,076h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,0FEh,0C0h,0C0h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,038h,06Ch,064h,060h,0F0h,060h,060h,060h,060h,0F0h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,076h,0CCh,0CCh,0CCh,0CCh,0CCh,07Ch,00Ch,0CCh,078h,000h
	db	000h,000h,0E0h,060h,060h,06Ch,076h,066h,066h,066h,066h,0E6h,000h,000h,000h,000h
	db	000h,000h,018h,018h,000h,038h,018h,018h,018h,018h,018h,03Ch,000h,000h,000h,000h
	db	000h,000h,006h,006h,000h,00Eh,006h,006h,006h,006h,006h,006h,066h,066h,03Ch,000h
	db	000h,000h,0E0h,060h,060h,066h,06Ch,078h,078h,06Ch,066h,0E6h,000h,000h,000h,000h
	db	000h,000h,038h,018h,018h,018h,018h,018h,018h,018h,018h,03Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0ECh,0FEh,0D6h,0D6h,0D6h,0D6h,0C6h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0DCh,066h,066h,066h,066h,066h,066h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,0C6h,0C6h,0C6h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0DCh,066h,066h,066h,066h,066h,07Ch,060h,060h,0F0h,000h
	db	000h,000h,000h,000h,000h,076h,0CCh,0CCh,0CCh,0CCh,0CCh,07Ch,00Ch,00Ch,01Eh,000h
	db	000h,000h,000h,000h,000h,0DCh,076h,066h,060h,060h,060h,0F0h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,060h,038h,00Ch,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,010h,030h,030h,0FCh,030h,030h,030h,030h,036h,01Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0CCh,0CCh,0CCh,0CCh,0CCh,0CCh,076h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,066h,066h,066h,066h,066h,03Ch,018h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0D6h,0D6h,0D6h,0FEh,06Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,06Ch,038h,038h,038h,06Ch,0C6h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,07Eh,006h,00Ch,0F8h,000h
	db	000h,000h,000h,000h,000h,0FEh,0CCh,018h,030h,060h,0C6h,0FEh,000h,000h,000h,000h
	db	000h,000h,00Eh,018h,018h,018h,070h,018h,018h,018h,018h,00Eh,000h,000h,000h,000h
	db	000h,000h,018h,018h,018h,018h,000h,018h,018h,018h,018h,018h,000h,000h,000h,000h
	db	000h,000h,070h,018h,018h,018h,00Eh,018h,018h,018h,018h,070h,000h,000h,000h,000h
	db	000h,000h,076h,0DCh,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,010h,038h,06Ch,0C6h,0C6h,0C6h,0FEh,000h,000h,000h,000h,000h
	db	000h,000h,01Eh,036h,066h,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,0FEh,062h,062h,060h,07Ch,066h,066h,066h,066h,0FCh,000h,000h,000h,000h
	db	000h,000h,0FCh,066h,066h,066h,07Ch,066h,066h,066h,066h,0FCh,000h,000h,000h,000h
	db	000h,000h,0FEh,062h,062h,060h,060h,060h,060h,060h,060h,0F0h,000h,000h,000h,000h
	db	000h,000h,01Eh,036h,066h,066h,066h,066h,066h,066h,066h,0FFh,0C3h,081h,000h,000h
	db	000h,000h,0FEh,066h,062h,068h,078h,068h,060h,062h,066h,0FEh,000h,000h,000h,000h
	db	000h,000h,0D6h,0D6h,054h,054h,07Ch,07Ch,054h,0D6h,0D6h,0D6h,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,006h,006h,03Ch,006h,006h,006h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0CEh,0CEh,0D6h,0E6h,0E6h,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	038h,038h,0C6h,0C6h,0CEh,0CEh,0D6h,0E6h,0E6h,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,0E6h,066h,06Ch,06Ch,078h,078h,06Ch,06Ch,066h,0E6h,000h,000h,000h,000h
	db	000h,000h,01Eh,036h,066h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,0C6h,0EEh,0FEh,0FEh,0D6h,0C6h,0C6h,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,0FEh,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,0FCh,066h,066h,066h,07Ch,060h,060h,060h,060h,0F0h,000h,000h,000h,000h
	db	000h,000h,03Ch,066h,0C2h,0C0h,0C0h,0C0h,0C0h,0C2h,066h,03Ch,000h,000h,000h,000h
	db	000h,000h,07Eh,05Ah,018h,018h,018h,018h,018h,018h,018h,03Ch,000h,000h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0C6h,07Eh,006h,006h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,03Ch,018h,07Eh,0DBh,0DBh,0DBh,0DBh,0DBh,07Eh,018h,03Ch,000h,000h,000h,000h
	db	000h,000h,0C6h,0C6h,06Ch,07Ch,038h,038h,07Ch,06Ch,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,0CCh,0CCh,0CCh,0CCh,0CCh,0CCh,0CCh,0CCh,0CCh,0FEh,006h,006h,000h,000h
	db	000h,000h,0C6h,0C6h,0C6h,0C6h,0C6h,07Eh,006h,006h,006h,006h,000h,000h,000h,000h
	db	000h,000h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0FEh,000h,000h,000h,000h
	db	000h,000h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0FFh,003h,003h,000h,000h
	db	000h,000h,0F8h,0B0h,030h,030h,03Eh,033h,033h,033h,033h,07Eh,000h,000h,000h,000h
	db	000h,000h,0C3h,0C3h,0C3h,0C3h,0F3h,0DBh,0DBh,0DBh,0DBh,0F3h,000h,000h,000h,000h
	db	000h,000h,0F0h,060h,060h,060h,07Ch,066h,066h,066h,066h,0FCh,000h,000h,000h,000h
	db	000h,000h,07Ch,0C6h,006h,026h,03Eh,026h,006h,006h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,0CEh,0DBh,0DBh,0DBh,0FBh,0DBh,0DBh,0DBh,0DBh,0CEh,000h,000h,000h,000h
	db	000h,000h,03Fh,066h,066h,066h,03Eh,03Eh,066h,066h,066h,0E7h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,078h,00Ch,07Ch,0CCh,0CCh,0CCh,076h,000h,000h,000h,000h
	db	000h,002h,006h,03Ch,060h,060h,07Ch,066h,066h,066h,066h,03Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0FCh,066h,066h,07Ch,066h,066h,0FCh,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Eh,032h,032h,030h,030h,030h,078h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,01Eh,036h,036h,066h,066h,066h,0FFh,0C3h,0C3h,000h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,0FEh,0C0h,0C0h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0D6h,0D6h,054h,07Ch,054h,0D6h,0D6h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,03Ch,066h,006h,00Ch,006h,066h,03Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0CEh,0D6h,0E6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,000h,038h,038h,0C6h,0C6h,0CEh,0D6h,0E6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0E6h,06Ch,078h,078h,06Ch,066h,0E6h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,01Eh,036h,066h,066h,066h,066h,066h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0EEh,0FEh,0FEh,0D6h,0D6h,0C6h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,0C6h,0C6h,0C6h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0FEh,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,000h,000h,000h,000h
	db	011h,044h,011h,044h,011h,044h,011h,044h,011h,044h,011h,044h,011h,044h,011h,044h
	db	055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh
	db	0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h
	db	018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,018h,018h,0F8h,018h,018h,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,0F8h,018h,0F8h,018h,018h,018h,018h,018h,018h,018h,018h
	db	036h,036h,036h,036h,036h,036h,036h,0F6h,036h,036h,036h,036h,036h,036h,036h,036h
	db	000h,000h,000h,000h,000h,000h,000h,0FEh,036h,036h,036h,036h,036h,036h,036h,036h
	db	000h,000h,000h,000h,000h,0F8h,018h,0F8h,018h,018h,018h,018h,018h,018h,018h,018h
	db	036h,036h,036h,036h,036h,0F6h,006h,0F6h,036h,036h,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,036h,036h,036h,036h,036h,036h,036h,036h,036h,036h,036h
	db	000h,000h,000h,000h,000h,0FEh,006h,0F6h,036h,036h,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,0F6h,006h,0FEh,000h,000h,000h,000h,000h,000h,000h,000h
	db	036h,036h,036h,036h,036h,036h,036h,0FEh,000h,000h,000h,000h,000h,000h,000h,000h
	db	018h,018h,018h,018h,018h,0F8h,018h,0F8h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,0F8h,018h,018h,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,018h,018h,01Fh,000h,000h,000h,000h,000h,000h,000h,000h
	db	018h,018h,018h,018h,018h,018h,018h,0FFh,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,0FFh,018h,018h,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,018h,018h,01Fh,018h,018h,018h,018h,018h,018h,018h,018h
	db	000h,000h,000h,000h,000h,000h,000h,0FFh,000h,000h,000h,000h,000h,000h,000h,000h
	db	018h,018h,018h,018h,018h,018h,018h,0FFh,018h,018h,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,01Fh,018h,01Fh,018h,018h,018h,018h,018h,018h,018h,018h
	db	036h,036h,036h,036h,036h,036h,036h,037h,036h,036h,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,037h,030h,03Fh,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,03Fh,030h,037h,036h,036h,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,0F7h,000h,0FFh,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0FFh,000h,0F7h,036h,036h,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,037h,030h,037h,036h,036h,036h,036h,036h,036h,036h,036h
	db	000h,000h,000h,000h,000h,0FFh,000h,0FFh,000h,000h,000h,000h,000h,000h,000h,000h
	db	036h,036h,036h,036h,036h,0F7h,000h,0F7h,036h,036h,036h,036h,036h,036h,036h,036h
	db	018h,018h,018h,018h,018h,0FFh,000h,0FFh,000h,000h,000h,000h,000h,000h,000h,000h
	db	036h,036h,036h,036h,036h,036h,036h,0FFh,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0FFh,000h,0FFh,018h,018h,018h,018h,018h,018h,018h,018h
	db	000h,000h,000h,000h,000h,000h,000h,0FFh,036h,036h,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,036h,036h,03Fh,000h,000h,000h,000h,000h,000h,000h,000h
	db	018h,018h,018h,018h,018h,01Fh,018h,01Fh,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,01Fh,018h,01Fh,018h,018h,018h,018h,018h,018h,018h,018h
	db	000h,000h,000h,000h,000h,000h,000h,03Fh,036h,036h,036h,036h,036h,036h,036h,036h
	db	036h,036h,036h,036h,036h,036h,036h,0FFh,036h,036h,036h,036h,036h,036h,036h,036h
	db	018h,018h,018h,018h,018h,0FFh,018h,0FFh,018h,018h,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,018h,018h,0F8h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,01Fh,018h,018h,018h,018h,018h,018h,018h,018h
	db	0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
	db	000h,000h,000h,000h,000h,000h,000h,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
	db	0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h
	db	00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh
	db	0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0DCh,066h,066h,066h,066h,066h,07Ch,060h,060h,0F0h,000h
	db	000h,000h,000h,000h,000h,07Ch,0C6h,0C0h,0C0h,0C0h,0C6h,07Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Eh,05Ah,018h,018h,018h,018h,03Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0C6h,0C6h,0C6h,07Eh,006h,006h,0C6h,07Ch,000h
	db	000h,000h,000h,000h,03Ch,018h,07Eh,0DBh,0DBh,0DBh,0DBh,07Eh,018h,018h,03Ch,000h
	db	000h,000h,000h,000h,000h,0C6h,06Ch,038h,038h,038h,06Ch,0C6h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0CCh,0CCh,0CCh,0CCh,0CCh,0CCh,0FEh,006h,006h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0C6h,0C6h,07Eh,006h,006h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0FEh,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0D6h,0D6h,0D6h,0D6h,0D6h,0D6h,0FFh,003h,003h,000h,000h
	db	000h,000h,000h,000h,000h,0F8h,0B0h,030h,03Eh,033h,033h,07Eh,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0C6h,0C6h,0C6h,0F6h,0DEh,0DEh,0F6h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0F0h,060h,060h,07Ch,066h,066h,0FCh,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,03Ch,066h,006h,01Eh,006h,066h,03Ch,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,0CEh,0DBh,0DBh,0FBh,0DBh,0DBh,0CEh,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,07Eh,0CCh,0CCh,0FCh,06Ch,0CCh,0CEh,000h,000h,000h,000h
	db	000h,000h,000h,0FEh,000h,000h,0FEh,000h,000h,0FEh,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,018h,018h,07Eh,018h,018h,000h,000h,000h,07Eh,000h,000h,000h,000h
	db	000h,000h,000h,030h,018h,00Ch,006h,00Ch,018h,030h,000h,07Eh,000h,000h,000h,000h
	db	000h,000h,000h,00Ch,018h,030h,060h,030h,018h,00Ch,000h,07Eh,000h,000h,000h,000h
	db	000h,00Eh,01Bh,01Bh,01Bh,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h
	db	018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,0D8h,0D8h,0D8h,070h,000h
	db	000h,000h,000h,000h,018h,018h,000h,07Eh,000h,018h,018h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,076h,0DCh,000h,076h,0DCh,000h,000h,000h,000h,000h,000h
	db	000h,038h,06Ch,06Ch,038h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,018h,018h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,018h,000h,000h,000h,000h,000h,000h,000h
	db	000h,00Fh,00Ch,00Ch,00Ch,00Ch,00Ch,00Ch,0ECh,07Ch,03Ch,01Ch,00Ch,000h,000h,000h
	db	000h,000h,03Ch,042h,099h,0A5h,0A1h,0A1h,0A5h,099h,042h,03Ch,000h,000h,000h,000h
	db	000h,070h,0D8h,030h,060h,0C8h,0F8h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,07Ch,07Ch,07Ch,07Ch,07Ch,07Ch,07Ch,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
end;

begin
  asm
        MOV   AX,1A00H          { 맮 VGA BIOS }
        INT   10H
        CMP   AL,1AH
        JE    @@1               { VGA BIOS 㦥... }
        MOV   BX,0FF10H
        MOV   CX,0FFFFH
        MOV   AX,1200H          { 맮 EGA BIOS }
        INT   10H
        CMP   CX,0FFFFH
        JE    @@2               { EGA BIOS  㦥... }
@@0:
        MOV   VideoId,viEGA
        JMP   @@2
@@1:
        CMP   BL,4
        JB    @@2
        CMP   BL,5
        JBE   @@0
        CMP   BL,7
        JB    @@2
        CMP   BL,8
        JA    @@2
        MOV   VideoId,viVGA
@@2:
  end;
  if VideoId = viVGA then
    begin
      @ScreenOff := @VGAScreenOff;
      @ScreenOn := @VGAScreenOn;
    end
  else
    begin
      @ScreenOff := @NothingToDo;
      @ScreenOn := @NothingToDo;
    end;
  FontRam := Ptr(SegB800,$0000);
end.
